﻿namespace TestProject;

/// <summary>
/// 연락처
/// </summary>
public class Contact
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 이름 - FirstName

    /// <summary>
    /// 이름
    /// </summary>
    public string FirstName { get; private set; }

    #endregion
    #region 성 - LastName

    /// <summary>
    /// 성
    /// </summary>
    public string LastName { get; private set; }

    #endregion
    #region 회사 - Company

    /// <summary>
    /// 회사
    /// </summary>
    public string Company { get; private set; }

    #endregion
    #region 성명 - Name

    /// <summary>
    /// 성명
    /// </summary>
    public string Name => $"{FirstName} {LastName}";

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 생성자 - Contact(firstName, lastName, company)

    /// <summary>
    /// 생성자
    /// </summary>
    /// <param name="firstName">이름</param>
    /// <param name="lastName">성</param>
    /// <param name="company">회사</param>
    public Contact(string firstName, string lastName, string company)
    {
        FirstName = firstName;
        LastName  = lastName;
        Company   = company;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 문자열 구하기 - ToString()

    /// <summary>
    /// 문자열 구하기
    /// </summary>
    /// <returns>문자열</returns>
    public override string ToString()
    {
        return Name;
    }

    #endregion
}