using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;

using Microsoft.UI.Xaml.Controls;

namespace TestProject;

/// <summary>
///  
/// </summary>
public sealed partial class MainPage : Page
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region Field

    /// <summary>
    /// ҽ ó Ʈ
    /// </summary>
    private IList<Contact> sourceContactList = new List<Contact>();

    /// <summary>
    /// Ÿ ó ÷
    /// </summary>
    private ObservableCollection<Contact> targetContectCollection;

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - MainPage()

    /// <summary>
    /// 
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        this.sourceContactList.Add(new Contact("Kendall" , "Collins", "Adatum Corporation"));
        this.sourceContactList.Add(new Contact("Victoria", "Burke"  , "Bellows College"   ));
        this.sourceContactList.Add(new Contact("Preston" , "Morales", "Margie's Travel"   ));
        this.sourceContactList.Add(new Contact("Miguel"  , "Reyes"  , "Tailspin Toys"     ));

        this.targetContectCollection = new ObservableCollection<Contact>(this.sourceContactList);

        this.listView.ItemsSource = this.targetContectCollection;

        this.filterTextBox.TextChanged += filterTextBox_TextChanged;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private
    //////////////////////////////////////////////////////////////////////////////// Event

    #region  ؽƮ ڽ ؽƮ  óϱ - filterTextBox_TextChanged(sender, e)

    /// <summary>
    ///  ؽƮ ڽ ؽƮ  óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">"̺Ʈ ></param>
    private void filterTextBox_TextChanged(object sender, TextChangedEventArgs e)
    {
        string filterString = (sender as TextBox).Text;

        IEnumerable<Contact> filteredContactEnumerable = this.sourceContactList.Where(contact => Filter(contact, filterString));

        RemoveContactNotInFilteredContactEnumerable(filteredContactEnumerable);

        AddContactNotInTargetContactCollection(filteredContactEnumerable);
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////// Function

    #region  óϱ - Filter(contact, filterString)

    /// <summary>
    ///  óϱ
    /// </summary>
    /// <param name="contact">ó</param>
    /// <param name="filterString"> ڿ</param>
    /// <returns> ó </returns>
    private bool Filter(Contact contact, string filterString)
    {
        return contact.LastName.Contains(filterString, StringComparison.InvariantCultureIgnoreCase);
    }

    #endregion
    #region  ó    ó ϱ - RemoveContactNotInFilteredContactEnumerable(filteredContactEnumerable)

    /// <summary>
    ///  ó    ó ϱ
    /// </summary>
    /// <param name="filteredContactEnumerable"> ó  </param>
    private void RemoveContactNotInFilteredContactEnumerable(IEnumerable<Contact> filteredContactEnumerable)
    {
       for(int i = this.targetContectCollection.Count - 1; i >= 0; i--)
       {
            Contact targetContact = this.targetContectCollection[i];

           if(!filteredContactEnumerable.Contains(targetContact))
           {
               this.targetContectCollection.Remove(targetContact);
           }
       }
    }

    #endregion
    #region Ÿ ó ÷ǿ  ó ߰ϱ - AddContactNotInTargetContactCollection(filteredContactEnumerable)

    /// <summary>
    /// Ÿ ó ÷ǿ  ó ߰ϱ
    /// </summary>
    /// <param name="filteredContactEnumerable"> ó  </param>
    private void AddContactNotInTargetContactCollection(IEnumerable<Contact> filteredContactEnumerable)
    {
       foreach(Contact filteredContact in filteredContactEnumerable)
       {
           if(!this.targetContectCollection.Contains(filteredContact))
           {
               this.targetContectCollection.Add(filteredContact);
           }
       }
    }

    #endregion
}